<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Sphere Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_sphere.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_sphere-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Sphere Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate spheres.  
 <a href="class_sphere.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_sphere_8hpp_source.html">Sphere.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Sphere:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_sphere.png" usemap="#Sphere_map" alt=""/>
  <map id="Sphere_map" name="Sphere_map">
<area href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). " alt="Surface" shape="rect" coords="0,0,57,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a890a63ff583cb88e7ec4e840b4ef5eb9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#a890a63ff583cb88e7ec4e840b4ef5eb9">Sphere</a> ()</td></tr>
<tr class="memdesc:a890a63ff583cb88e7ec4e840b4ef5eb9"><td class="mdescLeft">&#160;</td><td class="mdescRight">A simple constructor (don't use it directly).  <a href="#a890a63ff583cb88e7ec4e840b4ef5eb9">More...</a><br /></td></tr>
<tr class="separator:a890a63ff583cb88e7ec4e840b4ef5eb9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad736d31cbc3078179737e203f3fe2e28"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#ad736d31cbc3078179737e203f3fe2e28">Sphere</a> (<a class="el" href="class_vec.html">Vec</a> _o, double _radius, <a class="el" href="class_material.html">Material</a> *_m, bool _inv_normal)</td></tr>
<tr class="memdesc:ad736d31cbc3078179737e203f3fe2e28"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> constructor.  <a href="#ad736d31cbc3078179737e203f3fe2e28">More...</a><br /></td></tr>
<tr class="separator:ad736d31cbc3078179737e203f3fe2e28"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0963e7749cf2a3040b149b31cece46f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#aa0963e7749cf2a3040b149b31cece46f">Sphere</a> (std::string _id, <a class="el" href="class_vec.html">Vec</a> _o, double _radius, <a class="el" href="class_material.html">Material</a> *_m, bool _inv_normal)</td></tr>
<tr class="memdesc:aa0963e7749cf2a3040b149b31cece46f"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> constructor.  <a href="#aa0963e7749cf2a3040b149b31cece46f">More...</a><br /></td></tr>
<tr class="separator:aa0963e7749cf2a3040b149b31cece46f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc5160404dc9fa0d6a7ae8028dc1a7f1"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#abc5160404dc9fa0d6a7ae8028dc1a7f1">getRadius</a> ()</td></tr>
<tr class="memdesc:abc5160404dc9fa0d6a7ae8028dc1a7f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the radius of the sphere.  <a href="#abc5160404dc9fa0d6a7ae8028dc1a7f1">More...</a><br /></td></tr>
<tr class="separator:abc5160404dc9fa0d6a7ae8028dc1a7f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70c60796fb681dc31dbce78e3ca8c36b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#a70c60796fb681dc31dbce78e3ca8c36b">getPosLocalCoords</a> ()</td></tr>
<tr class="memdesc:a70c60796fb681dc31dbce78e3ca8c36b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the sphere in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="#a70c60796fb681dc31dbce78e3ca8c36b">More...</a><br /></td></tr>
<tr class="separator:a70c60796fb681dc31dbce78e3ca8c36b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab81f16923614f7ff3f5172239135ef72"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#ab81f16923614f7ff3f5172239135ef72">getPosWorldCoords</a> ()</td></tr>
<tr class="memdesc:ab81f16923614f7ff3f5172239135ef72"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the sphere in the world frame (after being affected by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> hierarchy).  <a href="#ab81f16923614f7ff3f5172239135ef72">More...</a><br /></td></tr>
<tr class="separator:ab81f16923614f7ff3f5172239135ef72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43f31e0eaf092bc14fe8be5c2051e659"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#a43f31e0eaf092bc14fe8be5c2051e659">setRadius</a> (double _radius)</td></tr>
<tr class="memdesc:a43f31e0eaf092bc14fe8be5c2051e659"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the radius of the sphere.  <a href="#a43f31e0eaf092bc14fe8be5c2051e659">More...</a><br /></td></tr>
<tr class="separator:a43f31e0eaf092bc14fe8be5c2051e659"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7679526478966e1e143360dfd12d57a3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#a7679526478966e1e143360dfd12d57a3">setPosLocalCoords</a> (<a class="el" href="class_vec.html">Vec</a> _centre)</td></tr>
<tr class="memdesc:a7679526478966e1e143360dfd12d57a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the position of the sphere in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="#a7679526478966e1e143360dfd12d57a3">More...</a><br /></td></tr>
<tr class="separator:a7679526478966e1e143360dfd12d57a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e7068ae2787aa9ff47eefe23b245c9f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#a8e7068ae2787aa9ff47eefe23b245c9f">bounding_box</a> ()</td></tr>
<tr class="memdesc:a8e7068ae2787aa9ff47eefe23b245c9f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the bounding box of the sphere.  <a href="#a8e7068ae2787aa9ff47eefe23b245c9f">More...</a><br /></td></tr>
<tr class="separator:a8e7068ae2787aa9ff47eefe23b245c9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab5aec7813daccf5bca5831cde5a30c00"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="class_box.html">Box</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#ab5aec7813daccf5bca5831cde5a30c00">getBBox</a> ()</td></tr>
<tr class="memdesc:ab5aec7813daccf5bca5831cde5a30c00"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the bounding box of this sphere.  <a href="#ab5aec7813daccf5bca5831cde5a30c00">More...</a><br /></td></tr>
<tr class="separator:ab5aec7813daccf5bca5831cde5a30c00"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af245199d60ad587999c8b4e10f2c8dc0"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#af245199d60ad587999c8b4e10f2c8dc0">getCentroid</a> ()</td></tr>
<tr class="memdesc:af245199d60ad587999c8b4e10f2c8dc0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the centroid of this sphere.  <a href="#af245199d60ad587999c8b4e10f2c8dc0">More...</a><br /></td></tr>
<tr class="separator:af245199d60ad587999c8b4e10f2c8dc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a52b2eaae5dac35fa93b5e254af875828"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#a52b2eaae5dac35fa93b5e254af875828">addSurfaces</a> (std::vector&lt; <a class="el" href="class_surface.html">Surface</a> *&gt; &amp;objects)</td></tr>
<tr class="memdesc:a52b2eaae5dac35fa93b5e254af875828"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds this sphere (its pointer, actually) to a given vector of surfaces.  <a href="#a52b2eaae5dac35fa93b5e254af875828">More...</a><br /></td></tr>
<tr class="separator:a52b2eaae5dac35fa93b5e254af875828"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb9d78112a4d75bff15caf6d4e7d0362"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#afb9d78112a4d75bff15caf6d4e7d0362">hit</a> (const <a class="el" href="class_ray.html">Ray</a> &amp;r, <a class="el" href="structhit__rec.html">hit_rec</a> &amp;h_r, double t_min, double t_max)</td></tr>
<tr class="memdesc:afb9d78112a4d75bff15caf6d4e7d0362"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if a given <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> intersects this <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> and, if so, a hit record is filled in.  <a href="#afb9d78112a4d75bff15caf6d4e7d0362">More...</a><br /></td></tr>
<tr class="separator:afb9d78112a4d75bff15caf6d4e7d0362"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_surface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_surface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_surface.html">Surface</a></td></tr>
<tr class="memitem:a66c78e81a329eee37ddad0dece149b96 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">Surface</a> (<a class="el" href="class_material.html">Material</a> *&amp;_m)</td></tr>
<tr class="memdesc:a66c78e81a329eee37ddad0dece149b96 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> constructor. This is not supposed to be called directly by the user.  <a href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">More...</a><br /></td></tr>
<tr class="separator:a66c78e81a329eee37ddad0dece149b96 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8fc57f2a15292135c00545c9d224ec68 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a8fc57f2a15292135c00545c9d224ec68">Surface</a> ()</td></tr>
<tr class="separator:a8fc57f2a15292135c00545c9d224ec68 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89de75c95cb550d432f3ea4ed1429db0 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a89de75c95cb550d432f3ea4ed1429db0">~Surface</a> ()</td></tr>
<tr class="separator:a89de75c95cb550d432f3ea4ed1429db0 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab59cc271b2fe0db25867fc16664cc22f inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">setID</a> (std::string _id)</td></tr>
<tr class="memdesc:ab59cc271b2fe0db25867fc16664cc22f inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a unique identifier for this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>.  <a href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">More...</a><br /></td></tr>
<tr class="separator:ab59cc271b2fe0db25867fc16664cc22f inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab13775c761a7b51a95b57d300b94a9c8 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">isSmoothShaded</a> ()</td></tr>
<tr class="memdesc:ab13775c761a7b51a95b57d300b94a9c8 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this surface should be renderered with smooth shading.  <a href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">More...</a><br /></td></tr>
<tr class="separator:ab13775c761a7b51a95b57d300b94a9c8 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae844c2766ec89af9dd6e65db59cf0b02 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">setSmoothShading</a> (bool _smooth_shading)</td></tr>
<tr class="memdesc:ae844c2766ec89af9dd6e65db59cf0b02 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this surface should be renderered with smooth shading.  <a href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">More...</a><br /></td></tr>
<tr class="separator:ae844c2766ec89af9dd6e65db59cf0b02 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab04a7e3f5f5b51061b014bdbcfd85107 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">getVertexPosLocalCoords</a> (int _i)</td></tr>
<tr class="memdesc:ab04a7e3f5f5b51061b014bdbcfd85107 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">More...</a><br /></td></tr>
<tr class="separator:ab04a7e3f5f5b51061b014bdbcfd85107 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80450b9cb334e067ddaacb4380149c8e inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">getVertexPosWorldCoords</a> (int _i)</td></tr>
<tr class="memdesc:a80450b9cb334e067ddaacb4380149c8e inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the i-th vertex in the world frame (after being affected by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> hierarchy).  <a href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">More...</a><br /></td></tr>
<tr class="separator:a80450b9cb334e067ddaacb4380149c8e inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a455dca43c650016886ea02320ed4a3 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">setVertexPosLocalCoords</a> (int _i, <a class="el" href="class_vec.html">Vec</a> _pos)</td></tr>
<tr class="memdesc:a7a455dca43c650016886ea02320ed4a3 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">More...</a><br /></td></tr>
<tr class="separator:a7a455dca43c650016886ea02320ed4a3 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ffcbcea002fc72862411a3edbd386a7 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_material.html">Material</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">getMaterial</a> ()</td></tr>
<tr class="memdesc:a1ffcbcea002fc72862411a3edbd386a7 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>.  <a href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">More...</a><br /></td></tr>
<tr class="separator:a1ffcbcea002fc72862411a3edbd386a7 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2110a2eb3f0279d59a52e2034069eaae inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a2110a2eb3f0279d59a52e2034069eaae">setMaterial</a> (<a class="el" href="class_material.html">Material</a> *_m)</td></tr>
<tr class="memdesc:a2110a2eb3f0279d59a52e2034069eaae inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> (via a pointer).  <a href="class_surface.html#a2110a2eb3f0279d59a52e2034069eaae">More...</a><br /></td></tr>
<tr class="separator:a2110a2eb3f0279d59a52e2034069eaae inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abcbeb2a388e4971bd7095ce57e85fb95 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95">setTransform</a> (<a class="el" href="class_transform.html">Transform</a> *_tf)</td></tr>
<tr class="memdesc:abcbeb2a388e4971bd7095ce57e85fb95 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Associates a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. The method <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b" title="Triggers the application of the transform provided with setTransform() to all Vertex objects associat...">transform()</a> can then be used to change the <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s pose/scale based on _tf.  <a href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95">More...</a><br /></td></tr>
<tr class="separator:abcbeb2a388e4971bd7095ce57e85fb95 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25a12923766c3df006fa32628fe6bd4b inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">getTransform</a> ()</td></tr>
<tr class="memdesc:a25a12923766c3df006fa32628fe6bd4b inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node associated with this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> through method setTransform.  <a href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">More...</a><br /></td></tr>
<tr class="separator:a25a12923766c3df006fa32628fe6bd4b inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10655735b685f4363df818a2c6fdfb9b inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b">transform</a> ()</td></tr>
<tr class="memdesc:a10655735b685f4363df818a2c6fdfb9b inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the application of the transform provided with <a class="el" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95" title="Associates a Transform node to this Surface. The method transform() can then be used to change the Su...">setTransform()</a> to all <a class="el" href="class_vertex.html" title="A class to create and manipulate 3D vertexes. ">Vertex</a> objects associated to this surface.  <a href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b">More...</a><br /></td></tr>
<tr class="separator:a10655735b685f4363df818a2c6fdfb9b inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a45d6c6c870fac7c2a885ad2e226334ad"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#a45d6c6c870fac7c2a885ad2e226334ad">radius</a></td></tr>
<tr class="memdesc:a45d6c6c870fac7c2a885ad2e226334ad"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>'s radius.  <a href="#a45d6c6c870fac7c2a885ad2e226334ad">More...</a><br /></td></tr>
<tr class="separator:a45d6c6c870fac7c2a885ad2e226334ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb39e77a4ce7a55f090af7be040fab7b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sphere.html#adb39e77a4ce7a55f090af7be040fab7b">inv_normal</a></td></tr>
<tr class="memdesc:adb39e77a4ce7a55f090af7be040fab7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating whether the normal vectors are to be pointing into the sphere's centre.  <a href="#adb39e77a4ce7a55f090af7be040fab7b">More...</a><br /></td></tr>
<tr class="separator:adb39e77a4ce7a55f090af7be040fab7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_attribs_class_surface"><td colspan="2" onclick="javascript:toggleInherit('pub_attribs_class_surface')"><img src="closed.png" alt="-"/>&#160;Public Attributes inherited from <a class="el" href="class_surface.html">Surface</a></td></tr>
<tr class="memitem:ac8918f57a731e9f129c4a2051d0bc15d inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_vertex.html">Vertex</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">vertexes</a></td></tr>
<tr class="memdesc:ac8918f57a731e9f129c4a2051d0bc15d inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vector of vertexes associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Derived classes must use this vector if bounding boxes and transforms are to be applied.  <a href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">More...</a><br /></td></tr>
<tr class="separator:ac8918f57a731e9f129c4a2051d0bc15d inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60490e6d2fe723957e8814289f538624 inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a60490e6d2fe723957e8814289f538624">id</a></td></tr>
<tr class="memdesc:a60490e6d2fe723957e8814289f538624 inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">A string containing a unique ID for the surface.  <a href="class_surface.html#a60490e6d2fe723957e8814289f538624">More...</a><br /></td></tr>
<tr class="separator:a60490e6d2fe723957e8814289f538624 inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65d1534766e141346af770b5e95503bf inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a65d1534766e141346af770b5e95503bf">b_box_def</a></td></tr>
<tr class="memdesc:a65d1534766e141346af770b5e95503bf inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating if a bounding box has been defined already.  <a href="class_surface.html#a65d1534766e141346af770b5e95503bf">More...</a><br /></td></tr>
<tr class="separator:a65d1534766e141346af770b5e95503bf inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99bb89c6eeea7dd90b3fda098b51422b inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_material.html">Material</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">m</a></td></tr>
<tr class="memdesc:a99bb89c6eeea7dd90b3fda098b51422b inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this surface.  <a href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">More...</a><br /></td></tr>
<tr class="separator:a99bb89c6eeea7dd90b3fda098b51422b inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7675dc7633490a99cd39620054e2bdb inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">smooth_shading</a></td></tr>
<tr class="memdesc:aa7675dc7633490a99cd39620054e2bdb inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating if Phong interpolation is to be used.  <a href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">More...</a><br /></td></tr>
<tr class="separator:aa7675dc7633490a99cd39620054e2bdb inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3cebceee209a3762a5dc2550d69064c inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">local_n</a></td></tr>
<tr class="memdesc:ad3cebceee209a3762a5dc2550d69064c inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the local frame of reference (computed elsewhere)  <a href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">More...</a><br /></td></tr>
<tr class="separator:ad3cebceee209a3762a5dc2550d69064c inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7df9cc390062b02fa30e18eaea47dc3b inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">n</a></td></tr>
<tr class="memdesc:a7df9cc390062b02fa30e18eaea47dc3b inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the global frame of reference - updated with <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b" title="Triggers the application of the transform provided with setTransform() to all Vertex objects associat...">transform()</a>  <a href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">More...</a><br /></td></tr>
<tr class="separator:a7df9cc390062b02fa30e18eaea47dc3b inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a676d836b2651caf205065fcd095a356b inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_box.html">Box</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a676d836b2651caf205065fcd095a356b">b_box</a></td></tr>
<tr class="memdesc:a676d836b2651caf205065fcd095a356b inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Bounding box (a <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> itself - currently a <a class="el" href="class_box.html">Box</a>) encompassing all vertexes of this surface.  <a href="class_surface.html#a676d836b2651caf205065fcd095a356b">More...</a><br /></td></tr>
<tr class="separator:a676d836b2651caf205065fcd095a356b inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_class_surface"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_class_surface')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="class_surface.html">Surface</a></td></tr>
<tr class="memitem:a444077659d77f2e034ae163cbb103134 inherit pro_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a444077659d77f2e034ae163cbb103134">tf</a></td></tr>
<tr class="memdesc:a444077659d77f2e034ae163cbb103134 inherit pro_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Set this variable with setTransform.  <a href="class_surface.html#a444077659d77f2e034ae163cbb103134">More...</a><br /></td></tr>
<tr class="separator:a444077659d77f2e034ae163cbb103134 inherit pro_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate spheres. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a890a63ff583cb88e7ec4e840b4ef5eb9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a890a63ff583cb88e7ec4e840b4ef5eb9">&sect;&nbsp;</a></span>Sphere() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Sphere::Sphere </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A simple constructor (don't use it directly). </p>

</div>
</div>
<a id="ad736d31cbc3078179737e203f3fe2e28"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad736d31cbc3078179737e203f3fe2e28">&sect;&nbsp;</a></span>Sphere() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Sphere::Sphere </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_radius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>_m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_inv_normal</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_o</td><td><a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>'s 3D location </td></tr>
    <tr><td class="paramname">_radius</td><td><a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>'s radius </td></tr>
    <tr><td class="paramname">_inv_normal</td><td>Flag stating whether the normal vectors are to be pointing into the sphere's centre </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa0963e7749cf2a3040b149b31cece46f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa0963e7749cf2a3040b149b31cece46f">&sect;&nbsp;</a></span>Sphere() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Sphere::Sphere </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_o</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_radius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>_m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_inv_normal</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td>A string containing the ID of the sphere </td></tr>
    <tr><td class="paramname">_o</td><td><a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>'s 3D location </td></tr>
    <tr><td class="paramname">_radius</td><td><a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>'s radius </td></tr>
    <tr><td class="paramname">_inv_normal</td><td>Flag stating whether the normal vectors are to be pointing into the sphere's centre </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a52b2eaae5dac35fa93b5e254af875828"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a52b2eaae5dac35fa93b5e254af875828">&sect;&nbsp;</a></span>addSurfaces()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Sphere::addSurfaces </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="class_surface.html">Surface</a> *&gt; &amp;&#160;</td>
          <td class="paramname"><em>objects</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds this sphere (its pointer, actually) to a given vector of surfaces. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">objects</td><td>The vector of surfaces that will receive this sphere. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="class_surface.html#a6eaec7d61d4a87ce7cd42089487850bf">Surface</a>.</p>

</div>
</div>
<a id="a8e7068ae2787aa9ff47eefe23b245c9f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e7068ae2787aa9ff47eefe23b245c9f">&sect;&nbsp;</a></span>bounding_box()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Sphere::bounding_box </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Computes the bounding box of the sphere. </p>

<p>Reimplemented from <a class="el" href="class_surface.html#a1dabf409cbd72a6cf1984a21304369ff">Surface</a>.</p>

</div>
</div>
<a id="ab5aec7813daccf5bca5831cde5a30c00"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab5aec7813daccf5bca5831cde5a30c00">&sect;&nbsp;</a></span>getBBox()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_box.html">Box</a> Sphere::getBBox </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the bounding box of this sphere. </p>
<dl class="section return"><dt>Returns</dt><dd>The bounding box of this sphere. </dd></dl>

<p>Reimplemented from <a class="el" href="class_surface.html#ae3cf222676c208dc301ffc1dacb028e1">Surface</a>.</p>

</div>
</div>
<a id="af245199d60ad587999c8b4e10f2c8dc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af245199d60ad587999c8b4e10f2c8dc0">&sect;&nbsp;</a></span>getCentroid()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Sphere::getCentroid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the centroid of this sphere. </p>
<dl class="section return"><dt>Returns</dt><dd>The centroid of this sphere. </dd></dl>

<p>Reimplemented from <a class="el" href="class_surface.html#a1b0c1c392cc14642a7ff88db7c16d0f0">Surface</a>.</p>

</div>
</div>
<a id="a70c60796fb681dc31dbce78e3ca8c36b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a70c60796fb681dc31dbce78e3ca8c36b">&sect;&nbsp;</a></span>getPosLocalCoords()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Sphere::getPosLocalCoords </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the position of the sphere in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>). </p>
<dl class="section return"><dt>Returns</dt><dd>The position of the sphere in the object frame. </dd></dl>

</div>
</div>
<a id="ab81f16923614f7ff3f5172239135ef72"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab81f16923614f7ff3f5172239135ef72">&sect;&nbsp;</a></span>getPosWorldCoords()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Sphere::getPosWorldCoords </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the position of the sphere in the world frame (after being affected by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> hierarchy). </p>
<dl class="section return"><dt>Returns</dt><dd>The position of the sphere in the world frame. </dd></dl>

</div>
</div>
<a id="abc5160404dc9fa0d6a7ae8028dc1a7f1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abc5160404dc9fa0d6a7ae8028dc1a7f1">&sect;&nbsp;</a></span>getRadius()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">double Sphere::getRadius </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the radius of the sphere. </p>
<dl class="section return"><dt>Returns</dt><dd>The radius of the sphere. </dd></dl>

</div>
</div>
<a id="afb9d78112a4d75bff15caf6d4e7d0362"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb9d78112a4d75bff15caf6d4e7d0362">&sect;&nbsp;</a></span>hit()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Sphere::hit </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_ray.html">Ray</a> &amp;&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a> &amp;&#160;</td>
          <td class="paramname"><em>h_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Checks if a given <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> intersects this <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a> and, if so, a hit record is filled in. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">r</td><td><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> to be tested </td></tr>
    <tr><td class="paramname">h_r</td><td>Hit record that stores the information regarding the intersection between r and this <a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>, provided that it ocurred </td></tr>
    <tr><td class="paramname">t_min</td><td>Controls the closest allowed intersection </td></tr>
    <tr><td class="paramname">t_max</td><td>Controls the furthest allowed intersection </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Flag stating if an intersection occurred </dd></dl>

<p>Reimplemented from <a class="el" href="class_surface.html#ad5b74adad1504d73dbed6e47bc011bca">Surface</a>.</p>

</div>
</div>
<a id="a7679526478966e1e143360dfd12d57a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7679526478966e1e143360dfd12d57a3">&sect;&nbsp;</a></span>setPosLocalCoords()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Sphere::setPosLocalCoords </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>_centre</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the position of the sphere in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>). </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_centre</td><td>The position of the shere in the object frame. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a43f31e0eaf092bc14fe8be5c2051e659"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a43f31e0eaf092bc14fe8be5c2051e659">&sect;&nbsp;</a></span>setRadius()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Sphere::setRadius </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_radius</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the radius of the sphere. </p>
<p>_radius The radius of the sphere. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="adb39e77a4ce7a55f090af7be040fab7b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adb39e77a4ce7a55f090af7be040fab7b">&sect;&nbsp;</a></span>inv_normal</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Sphere::inv_normal</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Flag stating whether the normal vectors are to be pointing into the sphere's centre. </p>

</div>
</div>
<a id="a45d6c6c870fac7c2a885ad2e226334ad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a45d6c6c870fac7c2a885ad2e226334ad">&sect;&nbsp;</a></span>radius</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Sphere::radius</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="class_sphere.html" title="A class to create and manipulate spheres. ">Sphere</a>'s radius. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_sphere_8hpp_source.html">Sphere.hpp</a></li>
<li>src/<a class="el" href="_sphere_8cpp.html">Sphere.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_sphere.html">Sphere</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
